#include "gba.h"

extern const u8 pgm[];
extern const u16 font_Palette[16];
extern const u8 font_Char[32*128/8*32/8 + 0];
s32 oprintf(s16 x,s16 y,s8 *fmt, ...);
void oprn_clear();

u16 cont,trg;                  // L[

void key_read(void){
    u16 ReadData = (*(vu16 *)REG_KEYINPUT ^ 0x03ff);
    trg  = ReadData & (ReadData ^ cont);
    cont = ReadData;
}

s8 title[4][13];

void AgbMain(){
	s32 i,j,idx;
	u16 m;
	
	DmaClear(3, 0,   VRAM,     VRAM_SIZE,            32);
	DmaClear(3, 160, OAM,      OAM_SIZE,             32);
	DmaClear(3, 0,   PLTT,     PLTT_SIZE,            32);
	DmaArrayCopy(3, font_Char, OBJ_MODE0_VRAM, 32);

	for(i=1;i<8;i++){
		for(j=0;j<16;j++){
			m=0;
			if(i & 1) m|=0x001f;
			if(i & 2) m|=0x03e0;
			if(i & 4) m|=0x7c00;
			if(j<2) m=0xffff;
			*((u16 *)OBJ_PLTT+(i-1)*16+j)=font_Palette[j] & m;
		}
	}
	*(vu16 *)REG_DISPCNT = DISP_OBJ_CHAR_1D_MAP | 
		DISP_MODE_0 | DISP_OBJ_ON | DISP_BG0_ON | DISP_BG1_ON | DISP_BG2_ON; // LCDC ON
	
	for(i=0;i<4;i++){
		memset(title[i],0,13);
		memcpy(title[i],(s8 *)0x09f000a0+0x40000*i,12);
	}
	idx=0;
	for(;;){
		oprn_clear();
		key_read();
		if((trg & D_KEY)&&(idx<3)) idx++;
		if((trg & U_KEY)&&(idx>0)) idx--;
		oprintf(0,10,"%C1***** JOYLOADER V1.1 *****");
		oprintf(40,50+idx*10,"%C0X");
		for(i=0;i<4;i++){
			oprintf(60,50+i*10,"%C2%d %s",i+1,title[i]);
		}
		if(trg & A_BUTTON){
			memcpy((void *)0x02000000,(void *)0x09f00000+0x40000*idx,0x40000);
			DmaClear(3, 0,   VRAM,     VRAM_SIZE,            32);
			DmaClear(3, 160, OAM,      OAM_SIZE,             32);
			DmaClear(3, 0,   PLTT,     PLTT_SIZE,            32);
			*((u8 *)0x03007ffa)=1;
			asm("mov sp,r3");
			asm("mov r0,#254");
			asm("swi 1");
			asm("swi 0");
		}
		else if(trg & START_BUTTON){
			DmaClear(3, 0,   VRAM,     VRAM_SIZE,            32);
			DmaClear(3, 160, OAM,      OAM_SIZE,             32);
			DmaClear(3, 0,   PLTT,     PLTT_SIZE,            32);
			asm("mov r1,#0x09f00000");
			asm("bx r1");
			asm("nop");
		}
		for(;;){
			if((*(vu16 *)REG_STAT & 1)==0) break;
		}
		for(;;){
			if(*(vu16 *)REG_STAT & 1) break;
		}
	}
}
